package com.kingdee.eas.custom.shengshen.utils;

import java.io.File;
import java.io.IOException;
import java.sql.SQLException;
import java.text.MessageFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;
import org.apache.commons.io.FileUtils;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.eas.base.permission.UserInfo;
import com.kingdee.eas.util.app.ContextUtil;
import com.kingdee.shr.base.syssetting.web.dynamic.util.DynamicUtil;
import com.kingdee.shr.base.syssetting.web.dynamic.util.MD5;
import com.kingdee.shr.base.syssetting.web.util.UserUtil;
import com.kingdee.shr.ext.emp.AssemblyDataHelper;
import com.kingdee.shr.ext.model.InductionEmpInfo;
import com.kingdee.util.StringUtils;

public class EnrollFileUtil {
	private  static  String DURL = "http://192.168.0.80:8080/easWebClient/download/DSF_Mod_373.pdf";
	
	
	@SuppressWarnings("unused")
	public static String  createPDFFile(HttpServletRequest request,Context ctx,Set<String> personSet ) throws BOSException, SQLException {
		List<InductionEmpInfo> modelObjList = AssemblyDataHelper.getEmploymentPersonData(ctx, personSet);
		List<Map<String, String>> dataList = new ArrayList<Map<String, String>>();
		try {
			assemblePDFData(modelObjList,dataList);
		} catch (ParseException e1) {
			e1.printStackTrace();
		}
		PDFFillInformationUtil pdfFillInformationUtil = new PDFFillInformationUtil();

		long time = new Date().getTime();
		// 获取当前登入人的 临时存储地址
		
		String userTempDirAbsolutePath = UserUtil.getUserTempDirAbsolutePath(request.getSession());
		// 判断路径是否存在 如果没有创建
				File userTempDirAbsolute = new File(userTempDirAbsolutePath);
				if (!userTempDirAbsolute.exists()) {
					userTempDirAbsolute.mkdir();
				}
				
	     String zipName =  "入职申请表"+time+".zip";
	    	      String zipNameHash = MD5.md5Hash(zipName);
	    	      String realFileName = getEncryRealFileName(ctx, zipNameHash);
	    	      String fileStr = zipNameHash;
//	    	      String home = System.getProperty("EAS_HOME");
//	    	      String sorPath = home + "/server/deploy/fileserver.ear/easWebClient/download/DSF_Mod_373.pdf";
		////////////////////////////////////////////////
		// 填充后的文件
		List<File> list = new ArrayList<>();
		try {
			
			byte[] bytesByNetURL = HttpClient3.getBytesByNetURL(DURL);
			for (int i = 0; i < dataList.size(); i++) {
				Map<String, String> map = dataList.get(i);
				String curname = StringUtils.cnulls(map.get("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_3_[0]"));
				String cname = StringUtils.cnulls(map.get("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_0_[0]"));
				String fileName =  curname + cname;
				if(StringUtils.isEmpty(fileName)) {
					fileName =  String.valueOf(i);
				}
				fileName = StringUtils.isEmpty(fileName)? String.valueOf(i) :fileName;
				File file = pdfFillInformationUtil.fillInformation(bytesByNetURL, dataList.get(i),userTempDirAbsolutePath,fileName+".pdf");
				list.add(file);
			}
			
	 	      String zipPath = userTempDirAbsolutePath + File.separator + realFileName;
    	      PDFFillInformationUtil.compress(zipPath, list);
    	      Map<String, String> param = new HashMap<>();
    	      param.put("method", "tmp");
    	      param.put("file", fileStr);
    	      param.put("filename", zipName);
    	      return DynamicUtil.assembleUrl("/shr/downloadfile.do", param).replaceAll("\\+", "%20");
		} catch (IOException e) {
			throw new RuntimeException(e);
		} catch (BOSException e) {
			throw new RuntimeException(e);
		} finally {
			// 删除源文件
			for (int i = 0; i < list.size(); i++) {
				FileUtils.deleteQuietly(list.get(i));
			}
		}
	}
	
	
 


	public static void  assemblePDFData(List<InductionEmpInfo> modelObjList,List<Map<String, String>> dataList) throws ParseException   {
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd"); 
		for  (int i = 0; i < modelObjList.size() ;i++) {
			Map<String, String> dataMap = new HashMap<>();
			InductionEmpInfo modelObj = modelObjList.get(i);
			// 中文姓 CFCHINESESURNAME
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_3_[0]", modelObj.getCurname());
			// 中文名 CFCHINESENAME
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_0_[0]", modelObj.getCname());
			// 葡文姓 CFPORTUGUESESURNAME
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_1_[0]", modelObj.getPurName());
			//// 葡文名 CFPORTUGUESENAME
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_2_[0]", modelObj.getPname());
			//// （62、64、Mo01、mO02）类型为20，其余都是15
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_15_[0]", modelObj.getCretype());
//			//// 证件编号编号 FIDCardNO FPassportNO
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_16_[0]", modelObj.getCertificate());
			if(!StringUtils.isEmpty(modelObj.getBirthday())) {
				Date date = dateFormat.parse(modelObj.getBirthday());  
				Calendar calendar =  Calendar.getInstance();  
				calendar.setTime(date);  
				// 提取年、月、日（注意：月份是从0开始的）  
				int year = calendar.get(java.util.Calendar.YEAR);  
				int month = calendar.get(java.util.Calendar.MONTH) + 1; // 月份加1以符合常规表示  
				int day = calendar.get(java.util.Calendar.DAY_OF_MONTH);  
				// 出生日期 FBirthday 日:
				dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField15_0_[0]", String.valueOf(day) );
				//月
				dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField14_0_[0]", String.valueOf(month));
				//年
				dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField13_0_[0]", String.valueOf(year));
			}
		    ////// 性别 FGender 1男,2女
			if(StringUtils.equals(modelObj.getGender(),"1")) {
				dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.RadioButtonListMTC_0_[0]", "2");
			}else if(StringUtils.equals(modelObj.getGender(),"2")) {
				dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.RadioButtonListMTC_0_[0]", "3");
			}
			// 街道名称
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_4_[0]", modelObj.getStreet());
			// 门牌
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_5_[0]", modelObj.getDoorNo());
			// 楼层 CFFloor
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_6_[0]", modelObj.getFloor());
			// 单位 CFCompany
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_7_[0]", modelObj.getCunit());
			// 大厦名称
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_8_[0]", modelObj.getBuildName());
			// 大厦坐别 CFBuilding
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_9_[0]", modelObj.getBuilding());
 			 //地址
			if(StringUtils.equals("01", modelObj.getLive()) ) {
				dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.RadioButtonListMTC_3_[0]", "2");
			}else if(StringUtils.equals("02", modelObj.getLive()) ) {
				dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.RadioButtonListMTC_3_[0]", "1");
			}else if(StringUtils.equals("03", modelObj.getLive()) ) {
				dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.RadioButtonListMTC_3_[0]", "3");
			}
			// 家庭电话 FHomePhone
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_19_[0]", modelObj.getPhone());
			// 手机号码 FMobile
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_18_[0]", modelObj.getMobile());
			// 电子邮箱 FEmail
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_17_[0]", modelObj.getEmail());
			// 雇主编号
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_10_[0]", modelObj.getComCode());
			// 联系电话 FPHONENUMBER
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_12_[0]", modelObj.getComPhone());
			// 公司名称 FName_L2
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_13_[0]", modelObj.getComName());
			//簽名
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField1_11_[0]", modelObj.getComName());
			// 入职日期 T_HR_EmpLaborRelation on fpersonId FEnterDate
			if(!StringUtils.isEmpty(modelObj.getEnterDate())) {
				Date date = dateFormat.parse(modelObj.getEnterDate());  
				Calendar calendar =  Calendar.getInstance();  
				calendar.setTime(date);  
				// 提取年、月、日（注意：月份是从0开始的）  
				int year = calendar.get(java.util.Calendar.YEAR);  
				int month = calendar.get(java.util.Calendar.MONTH) + 1; // 月份加1以符合常规表示  
				int day = calendar.get(java.util.Calendar.DAY_OF_MONTH);  
				// 出生日期 FBirthday 日:
				dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField15_1_[0]", String.valueOf(day) );
				//月
				dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField14_1_[0]", String.valueOf(month));
				//年
				dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField13_1_[0]", String.valueOf(year));
			}
			
			// 员工类别
			dataMap.put("pdfjs_internal_id_349R", modelObj.getEmpType());
			if(StringUtils.equals("01", modelObj.getEmpType()) ) {
				dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.RadioButtonListMTC_2_[0]", "2");
			}else if(StringUtils.equals("02", modelObj.getEmpType()) ) {
				dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.RadioButtonListMTC_2_[0]", "3");
			} 
			//填写日期;
			Calendar calendar =  Calendar.getInstance();  
			calendar.setTime(new Date());  
			// 提取年、月、日（注意：月份是从0开始的）  
			int year = calendar.get(java.util.Calendar.YEAR);  
			int month = calendar.get(java.util.Calendar.MONTH) + 1; // 月份加1以符合常规表示  
			int day = calendar.get(java.util.Calendar.DAY_OF_MONTH);  
			// 出生日期 FBirthday 日:
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField15_2_[0]", String.valueOf(day) );
			//月
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField14_2_[0]", String.valueOf(month));
			//年
			dataMap.put("topmostSubform[0].Page1[0].topmostSubform_0_\\.Page1_0_\\.TextField13_2_[0]", String.valueOf(year));
			
			dataList.add(dataMap);
		}
		
	}
	
	
	
	public static String getEncryRealFileName(Context ctx, String realFileName) {
	    UserInfo currentUserInfo = ContextUtil.getCurrentUserInfo(ctx);
	    return MessageFormat.format("{0}_{1}", new Object[] { realFileName, MD5.md5Hash(currentUserInfo.getId().toString()) });
	  }
	
}
