package com.kingdee.shr.ext.ats.function;

import java.text.SimpleDateFormat;
import java.util.Map;

import org.apache.log4j.Logger;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.hr.ats.AttencePolicyInfo;
import com.kingdee.eas.hr.ats.AttendanceFileFactory;
import com.kingdee.eas.hr.ats.AttendanceFileInfo;
import com.kingdee.eas.hr.ats.WorkCalendarFactory;
import com.kingdee.eas.hr.ats.WorkCalendarInfo;
import com.kingdee.eas.hr.ats.WorkCalendarItemCollection;
import com.kingdee.eas.hr.ats.WorkCalendarItemFactory;
import com.kingdee.eas.hr.ats.WorkCalendarItemInfo;
import com.kingdee.eas.hr.ats.app.formula.calculate.data.Tools;
import com.kingdee.eas.hr.ats.common.AttendanceConstants;
import com.kingdee.eas.hr.ats.function.AtsCalFunctionService;






public class AtsCalFunctionExtService extends AtsCalFunctionService{
	private static Logger logger = Logger.getLogger(AtsCalFunctionExtService.class);
	private Context ctx;
	private SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	private SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
	
	
	public AtsCalFunctionExtService()
	{
	  this.ctx = Tools.getInstance().getCtx();
	}
	
	
	
	public double getCurrentWorkDayType(Map paramMap)
		    throws EASBizException, BOSException
		  {
		    String personId = (String)paramMap.get("T_HR_ATS_ATTENDANCERESULT_FPROPOSERID");
		    String currDateStr = (String)paramMap.get("T_HR_ATS_ATTENDANCERESULT_FATTENCEDATE");
		    Map globalMap = (Map)paramMap.get("globalMapKey");
		    double value = -1.0D;
		    AttendanceFileInfo fileInfo = null;
		    if (AttendanceConstants.isUseNew) {
		      Map fileInfoObject = (Map)globalMap.get("T_HR_ATS_AttendanceFile");
		      if (fileInfoObject != null) {
		        fileInfo = (AttendanceFileInfo)fileInfoObject.get(new StringBuilder().append(personId).append("_").append(currDateStr).toString());
		      }
		      Map policyInfoMap = null;
		      AttencePolicyInfo policy = null;
		      if ((fileInfo != null) && (fileInfo.getAttencePolicy() != null) && (fileInfo.getAttencePolicy().getId() != null)) {
		        policyInfoMap = (Map)globalMap.get("T_HR_ATS_AttencePolicy");
		        if ((policyInfoMap != null) && (policyInfoMap.size() > 0)) {
		          policy = (AttencePolicyInfo)policyInfoMap.get(fileInfo.getAttencePolicy().getId().toString());
		        }
		      }

		      String workCalendarId = ((policy != null) && (policy.getWorkCalendar() != null) && (policy.getWorkCalendar().getId() != null)) ? policy.getWorkCalendar().getId().toString() : "";

		      Map workCalendarItemInfoMap = null;
		      workCalendarItemInfoMap = (Map)globalMap.get("workItemMap");
		      if ((workCalendarItemInfoMap != null) && (workCalendarItemInfoMap.size() > 0)) {
		        WorkCalendarItemInfo workCalendarItemInfo = (WorkCalendarItemInfo)workCalendarItemInfoMap.get(new StringBuilder().append(workCalendarId).append("_").append(currDateStr).toString());
		        value = ((workCalendarItemInfo != null) && (workCalendarItemInfo.getDayType() != null)) ? workCalendarItemInfo.getDayType().getValue() : -1.0D;
		      }
		    } else {
		      String oql = new StringBuilder().append(" select *, attencePolicy.workCalendar\t where proposer ='").append(personId).append("' ").toString();
		      fileInfo = AttendanceFileFactory.getLocalInstance(this.ctx).getAttendanceFileInfo(oql);

		      WorkCalendarItemCollection itemsCollection = new WorkCalendarItemCollection();
		      if (fileInfo.getAttencePolicy() != null) {
		        String workCalendarId = fileInfo.getAttencePolicy().getWorkCalendar().getId().toString();
		        WorkCalendarInfo workCalendarInfo = WorkCalendarFactory.getLocalInstance(this.ctx).getWorkCalendarInfo(new StringBuilder().append(" where id = '").append(workCalendarId).append("' ").toString());
		        itemsCollection = WorkCalendarItemFactory.getLocalInstance(this.ctx).getWorkCalendarItemCollection(new StringBuilder().append(" where calendarGroup = '").append(workCalendarInfo.getId()).append("' and date='").append(currDateStr).append("'  ").toString());
		      }

		      if (itemsCollection.size() > 0) {
		        value = itemsCollection.get(0).getDayType().getValue();
		      }

		      if (itemsCollection.size() == 0) {
		        WorkCalendarInfo workInfo = WorkCalendarFactory.getLocalInstance(this.ctx).getWorkCalendarInfo(" where isDefault = 1 ");
		        WorkCalendarItemCollection itemsColl = WorkCalendarItemFactory.getLocalInstance(this.ctx).getWorkCalendarItemCollection(new StringBuilder().append(" where calendarGroup = '").append(workInfo.getId()).append("' and date='").append(currDateStr).append("'  ").toString());

		        if (itemsColl.size() > 0) {
		          value = itemsColl.get(0).getDayType().getValue();
		        }
		      }
		    }
		    return value;
		  }

	
	
}
