package com.kingdee.shr.ext.emp;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.apache.log4j.Logger;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
 
import com.kingdee.bos.util.backport.Arrays;
import com.kingdee.eas.base.permission.util.ToolUtils;
import com.kingdee.eas.basedata.person.IPerson;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.ext.model.InductionEmpInfo;
import com.kingdee.util.StringUtils;

/**
 * 数据组合
 * @author kkuan
 */
public class   AssemblyDataHelper {
	private static Logger logger = Logger.getLogger(AssemblyDataHelper.class);
	//证件类型编码
	private static String[] creTypes = {"62","64","Mo01","mO02"};
	
	
	/**
	 * @param ctx
	 * @param PersonIds
	 * @throws BOSException
	 * @throws SQLException 
	 */
	public static List<InductionEmpInfo> getEmploymentPersonData(Context ctx, Set<String> personIds) throws BOSException, SQLException {
		   IPerson personIns = PersonFactory.getLocalInstance(ctx);
//		   EntityViewInfo evi = new EntityViewInfo();
//		   FilterInfo fil = new FilterInfo();
//		   fil.getFilterItems().add(new FilterItemInfo("id", PersonIds, CompareType.INCLUDE));
//		   evi.setFilter(fil);
//		   PersonCollection personCollection = personIns.getPersonCollection(evi);
		   //人员
		   
		   Map<String, String> empType = getEmpType(ctx);
		   Map<String, String> liveMap = getLive(ctx);
		   Map<String, String> personsourceMap = getPersonsource(ctx); 
		   List<InductionEmpInfo> empDataList = new ArrayList();
		   IRowSet personDt  = checkPersonDtSql(ctx, personIds);
		   
		   while(personDt.next()) {
			   InductionEmpInfo inductionEmpInfo = new InductionEmpInfo();
			   //中文姓  	CFCHINESESURNAME
			   inductionEmpInfo.setCurname(StringUtils.cnulls(personDt.getString("curname"))); 
			   //中文名  	CFCHINESENAME
			   inductionEmpInfo.setCname(StringUtils.cnulls(personDt.getString("cname"))); 
			   //葡文姓	CFPORTUGUESESURNAME
			   inductionEmpInfo.setPurName(StringUtils.cnulls(personDt.getString("purname"))); 
			   //葡文名	CFPORTUGUESENAME
			   inductionEmpInfo.setPname(StringUtils.cnulls(personDt.getString("pname")));
			   //证件类型  FCredentialsTypeID  T_HR_PersonOtherInfo   T_HR_CredentialsType  cretype
			   //（62、64、Mo01、mO02）类型为20，其余都是15
			   if(Arrays.asList(creTypes).contains(StringUtils.cnulls(personDt.getString("cretypeNum")))  ) {
				   inductionEmpInfo.setCretype("20");
			   }else {
				   inductionEmpInfo.setCretype("15");
			   }
			   //证件编号编号  FIDCardNO   FPassportNO
			   if(!StringUtils.isEmpty(personDt.getString("idcard"))) {
				   inductionEmpInfo.setCertificate(StringUtils.cnulls(personDt.getString("idcard")));
			   }else {
				   inductionEmpInfo.setCertificate(StringUtils.cnulls(personDt.getString("passport")));
			   }
			   //出生日期  FBirthday
			   inductionEmpInfo.setBirthday(StringUtils.cnulls(personDt.getString("birthday")));
			   //性别      FGender 
			   inductionEmpInfo.setGender (StringUtils.cnulls(personDt.getString("gender")));
			   //员工类别          CT_MP_Persontype			
			   String empTypeName = empType.get(StringUtils.cnulls(personDt.getString("persontype")));
			   inductionEmpInfo.setEmpType(empTypeName);		
			   //街道名称   
			   inductionEmpInfo.setStreet (StringUtils.cnulls(personDt.getString("street")));
			   //门牌   
			   inductionEmpInfo.setDoorNo (StringUtils.cnulls(personDt.getString("doorNo")));
			   //楼层 CFFloor
			   inductionEmpInfo.setFloor (StringUtils.cnulls(personDt.getString("floor")));
			   //单位 CFCompany
			   inductionEmpInfo.setCunit (StringUtils.cnulls(personDt.getString("cunit")));
			   //大厦名称  CFBuildingName
			   inductionEmpInfo.setBuildName (StringUtils.cnulls(personDt.getString("build")));
			   //大厦坐别  CFBuilding
			   inductionEmpInfo.setBuilding (StringUtils.cnulls(personDt.getString("building")));
			   //地址   CT_MP_Live  CFLiveID
			   String liveName = liveMap.get(StringUtils.cnulls(personDt.getString("liveId")));
			   inductionEmpInfo.setLive ( liveName );
			   //家庭电话  FHomePhone 
			   inductionEmpInfo.setPhone  (StringUtils.cnulls(personDt.getString("phone")));
			   //手机号码  FMobile
			   inductionEmpInfo.setMobile  (StringUtils.cnulls(personDt.getString("mobile")));
			   //电子邮箱  FEmail
			   inductionEmpInfo.setEmail (StringUtils.cnulls(personDt.getString("email")));
			   //雇主编号  on fpersonId T_HR_PersonPosition   on FPersonDep  T_ORG_Admin    FCode
			   inductionEmpInfo.setComCode (StringUtils.cnulls(personDt.getString("comcode")));
			   //联系电话   FPHONENUMBER 
			   inductionEmpInfo.setComPhone  (StringUtils.cnulls(personDt.getString("comphone")));
			   //公司名称	FName_L2
			   inductionEmpInfo.setComName  (StringUtils.cnulls(personDt.getString("comName")));
			   //入职日期   T_HR_EmpLaborRelation  on fpersonId   FEnterDate
			   inductionEmpInfo.setEnterDate  (StringUtils.cnulls(personDt.getString("enterDate")));
			   // personDt.getString(" ")
			   //yaugong
			   inductionEmpInfo.setEnterDate  (StringUtils.cnulls(personDt.getString("enterDate")));
			    
			 //員工來源
			   //如果为本地雇员，地址统一，街道名称：石排灣馬路
			   //楼层：地下 ，
			   //大厦：    聯生工業邨B1街區+公司名称,默认为路环；
			   String sourceNum = personsourceMap.get(StringUtils.cnulls(personDt.getString("sourceId")));
			   if(StringUtils.equals("01", sourceNum)) {
				   //街道名称   
				   inductionEmpInfo.setStreet ("石排灣馬路");
				   //门牌   
				   inductionEmpInfo.setDoorNo ("");
				   //楼层 CFFloor
				   inductionEmpInfo.setFloor ("地下");
				   //单位 CFCompany
				   inductionEmpInfo.setCunit (StringUtils.cnulls(personDt.getString("cunit")));
				   //大厦名称  CFBuildingName
				   inductionEmpInfo.setBuildName ("聯生工業邨B1街區"+StringUtils.cnulls(personDt.getString("cunit")));
				   //大厦坐别  CFBuilding
				   inductionEmpInfo.setBuilding (StringUtils.cnulls(personDt.getString("building")));
				   //地址   CT_MP_Live  CFLiveID
				   inductionEmpInfo.setLive ("03") ;
			   } 
			   empDataList.add(inductionEmpInfo);
		   }
		return empDataList;
		
		
	}
	
	
	/**
	 * 获取员工类别  ;
	 * @param ctx
	 * @return
	 * @throws BOSException 
	 * @throws SQLException 
	 */
	private  static Map<String,String> getEmpType(Context ctx) throws BOSException, SQLException{
		 Map<String, String> hashMap = new HashMap<String,String> ();
		//员工类别      CFPersontypeID   CT_MP_Persontype		
		 String checkEmpType = " SELECT FID , FNUMBER FNAME FROM  CT_MP_Persontype ";
		 IRowSet da  = DbUtil.executeQuery( ctx, checkEmpType);
		 while(da.next()) {
			 hashMap.put(StringUtils.cnulls(da.getString("FID")), StringUtils.cnulls(da.getString("FNAME"))); 
		 }
		return hashMap;
	}
	
	
	
	/**
	 * 地址   CT_MP_Live 
	 * @param ctx
	 * @return
	 * @throws BOSException 
	 * @throws SQLException 
	 */
	private static Map<String,String> getLive(Context ctx) throws BOSException, SQLException{
		Map<String, String> hashMap = new HashMap<String,String> ();
		// 	
		String checkEmpType = " SELECT FID , FNUMBER  FNAME FROM  CT_MP_Live ";
		IRowSet da  = DbUtil.executeQuery( ctx, checkEmpType);
		while(da.next()) {
			hashMap.put(StringUtils.cnulls(da.getString("FID")), StringUtils.cnulls(da.getString("FNAME"))); 
		}
		 
		return hashMap;
	}
	
	/**
	 *  員工來源
	 * @param ctx
	 * @return
	 * @throws BOSException 
	 * @throws SQLException 
	 */
	private static Map<String,String> getPersonsource(Context ctx) throws BOSException, SQLException{
		Map<String, String> hashMap = new HashMap<String,String> ();
		// 	
		String checkEmpType = " SELECT FID , FNUMBER  FNAME FROM  CT_MP_Personsource ";
		IRowSet da  = DbUtil.executeQuery( ctx, checkEmpType);
		while(da.next()) {
			hashMap.put(StringUtils.cnulls(da.getString("FID")), StringUtils.cnulls(da.getString("FNAME"))); 
		}
		 
		return hashMap;
	}
	
	private  static IRowSet checkPersonDtSql (Context ctx, Set personIds) throws BOSException {
		 //地址   CT_MP_Live  CFLiveID
		   StringBuilder  abd = new StringBuilder();
		   abd.append(" SELECT                                                       ");
		   abd.append(" PERSON.CFCHINESESURNAME  curname ,                           ");
		   abd.append(" PERSON.CFCHINESENAME cname ,                                 ");
		   abd.append(" PERSON.CFPORTUGUESESURNAME  purname ,                        ");
		   abd.append(" PERSON.CFPORTUGUESENAME pname ,                              ");
		   abd.append(" PERSON.FIDCardNO idcard , PERSON.FPassportNO  passport ,     ");
		   abd.append(" PERSON.FBirthday  birthday , PERSON.FGender  gender,         ");
		   abd.append(" PERSON.CFPersontypeID persontype   ,                         ");
		   abd.append(" PERSON.CFPERSONSOURCEID  sourceId,     ");
		   abd.append(" CRETYPE.FNUMBER   cretypeNum,                         		 ");
		   abd.append(" CONTACT.cfstreetname  street , CONTACT.cfdoornumber doorno , ");
		   abd.append(" CONTACT.CFFloor floor, CONTACT.CFCompany cunit ,          ");
		   abd.append(" CONTACT.CFBuildingName build , CONTACT.CFBuilding  building, ");
		   abd.append(" CONTACT.CFLiveID    liveId , CONTACT.FHomePhone  phone ,     ");
		   abd.append(" CONTACT.FMobile  mobile, CONTACT.FEmail  email ,             ");
		   abd.append(" ADMINORG.FCode comcode , ADMINORG.FPHONENUMBER  comphone,    ");
		   abd.append(" ADMINORG.FName_L3  comname,                                  ");
		   abd.append(" LABOR.FEnterDate enterDate                                   ");
		   abd.append(" FROM   T_BD_person  PERSON                                   ");
		   
		   //证件类型
		   abd.append(" LEFT JOIN  T_HR_PersonOtherInfo  OTHERP                      ");
		   abd.append(" ON PERSON.FID = OTHERP.FPERSONID 	                         ");
		   abd.append(" LEFT JOIN  T_HR_CredentialsType   CRETYPE                    ");
		   abd.append(" ON OTHERP.FCredentialsTypeID = CRETYPE.FID                   ");
		   //联系方式
		   abd.append(" LEFT JOIN  T_HR_PersonContactMethod  CONTACT 	             ");
		   abd.append(" ON PERSON.FID = CONTACT.FPERSONID                            ");
		   
		   //公司
		   abd.append(" LEFT JOIN  T_HR_PersonPosition  POSITION                     ");
		   abd.append(" ON PERSON.FID = POSITION.FPERSONID                           ");
		   abd.append(" LEFT JOIN  T_ORG_Admin  ADMINORG                             ");
		   abd.append(" ON  POSITION.FCOMPANYID = ADMINORG.FID                                ");
		   abd.append(" LEFT JOIN  T_HR_EmpLaborRelation   LABOR                     ");
		   abd.append(" ON PERSON.FID = LABOR.FPERSONID                              ");
		   //where
		   abd.append(" WHERE PERSON.FID  IN ("+ ToolUtils.aryToStr(personIds)+")" 	);                  

		   IRowSet da = DbUtil.executeQuery( ctx, abd.toString());
		
		   return da;
		
	}

}
