package com.kingdee.eas.custom.ssPDF.handler;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.eas.base.permission.UserInfo;
import com.kingdee.eas.util.app.ContextUtil;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.web.dynamic.util.DynamicUtil;
import com.kingdee.shr.base.syssetting.web.dynamic.util.MD5;
import com.kingdee.shr.base.syssetting.web.util.UserUtil;
import com.kingdee.shr.compensation.web.handler.CmpReportDynamicListHandler;
import org.apache.commons.lang.StringUtils;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.nio.charset.Charset;
import java.sql.Date;
import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.Map;

/**
 * ʤTXT
 */
public class CmpReportDynamicListHandlerEx extends CmpReportDynamicListHandler {

    /**
     * ԱӦ֯  
     * 
     * Աѯ ͳ
     * Ĭ 32
     * ԱϢ--˰
     * ԱϢ-- (Big-5a)
     * ԱϢ--
     * н--Ӧ˰ö
     * 
     * 
     * н--ְҵ˰
     * Աְ
     * Ĭ 01
     * Ĭ 02
     * 
     */

    public void importTXTAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        Map<String, String> map = new HashMap<>();;
        try {
            String data = request.getParameter("data");
            JSONArray jsonArray = (JSONArray) JSONArray.parse(data);
            Context ctx = SHRContext.getInstance().getContext();//
            long time = System.currentTimeMillis();
            HttpSession session = request.getSession();
            String tempFilePath = UserUtil.getUserTempDirAbsolutePath(session); //
            File tempFile = new File(tempFilePath);
            if (!tempFile.exists()) {
                tempFile.mkdirs();
            }
            //  FileWriter дıļ
            String fileName = "output_" + time + ".txt";
            String txtNameHash = MD5.md5Hash(fileName);
            String realFileName = getEncryRealFileName(ctx,txtNameHash);
            String txtPath = tempFilePath + File.separator + realFileName;
            String fileStr = txtNameHash;
            FileWriter fileWriter = new FileWriter(txtPath);
            BufferedWriter bufferedWriter = new BufferedWriter(fileWriter);
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject jsonObject = (JSONObject) jsonArray.get(i);
                String personId = (String) jsonObject.get("personId");
                String ctbPeriodyear = String.valueOf(jsonObject.get("ctbPeriodyear"));//
                String ctbMonth = String.valueOf(jsonObject.get("ctbMonth"));
                String calNumber = (String) jsonObject.get("calNumber");//
                String dataTxt = getSql(ctx, personId, ctbPeriodyear, ctbMonth, calNumber);
                bufferedWriter.write(dataTxt);
            }
            // ر BufferedWriter
            bufferedWriter.close();
            // ر FileWriter
            fileWriter.close();

            Map<String, String> param = new HashMap<String, String>();
            param.put("method", "tmp");
            param.put("file", fileStr);
            param.put("filename",fileName);
            String link = DynamicUtil.assembleUrl("/shr/downloadfile.do", param).replaceAll("\\+", "%20");
            map.put("msgType","1");
            map.put("link",link);
            map.put("msg","سɹ");
        } catch (Exception e) {
            e.printStackTrace();
            map.put("msg",e.getMessage());
            map.put("msgType","0");
        }

        this.writeSuccessData(map);
    }

    /**
     * 9.9汾 url
     * @param ctx
     * @param realFileName
     * @return
     */
    public static String getEncryRealFileName(Context ctx, String realFileName) {
        UserInfo currentUserInfo = ContextUtil.getCurrentUserInfo(ctx);
        return MessageFormat.format("{0}_{1}", realFileName, MD5.md5Hash(currentUserInfo.getId().toString()));
    }

    /**
     * ȥЧλ
     * @param strNumber
     * @return
     */
    public static String removeTrailingZeros(String strNumber) {
        String pattern = "\\.?0*$"; // ƥСС㱾
        String formattedNumber = strNumber.replaceAll(pattern, "");
        return formattedNumber;
    }


    /**
     *
     * @param personId
     * @param ctbPeriodyear ͳ
     * @param ctbMonth ͳ
     * @param calNumber 
     *
     *
     */
    public String getSql(Context ctx,String personId,String ctbPeriodyear,String ctbMonth,String calNumber) throws Exception {
        SimpleDateFormat outputFormatter = new SimpleDateFormat("dd/MM/yyyy");
        StringBuilder query = new StringBuilder();
        query.append("SELECT").append("\n");
        query.append("org.Fname_l2 orgName,").append("\n");
        query.append("org.FCode as orgCode,").append("\n");
        query.append("person.CFOccupationcode personOccTion,").append("\n");
        query.append("person.CFChinesesurname personChineX,").append("\n");
        query.append("person.CFChinesename personChineM,").append("\n");
        query.append("person.CFPortuguesesurname personPX,").append("\n");
        query.append("person.CFPortuguesename personPM,").append("\n");
        query.append("sc.S5 s5,").append("\n");
        query.append("sc.S93 s93,").append("\n");
        query.append("res.FBIZDATE bizDate").append("\n");
        query.append("FROM T_HR_SCmpCalTable sc ").append("\n");
        query.append("left join T_HR_SCalScheme ch on sc.FCALSCHEMEID = ch.fid").append("\n");
        query.append("left join t_hr_personposition pp on sc.FPERSONID = pp.FPERSONID ").append("\n");
        query.append("left join T_BD_PERSON person on pp.FPERSONID = person.fid ").append("\n");
        query.append("left join T_Org_admin org on org.fid = pp.FCOMPANYID").append("\n");
        query.append("left join T_HR_ResignBizBillEntry res on res.FPERSONID = person.fid").append("\n");
        query.append("where sc.FPERSONID = '"+personId+"' and sc.FPERIODYEAR = '"+ctbPeriodyear+"' and sc.FPERIODMONTH = '"+ctbMonth+"' and ch.FNumber  = '"+calNumber+"'").append("\n");
        IRowSet rowSet = DbUtil.executeQuery(ctx, query.toString());
        String orgCode = "";//
        String taxFile = "";//Ӫҵ˰Żlֲ

        String clauseNumber = "32";//ְҵ˰
        String personOccTion = "";
        String ChineName = "";
        String ChinePWName = "";
        String s5Str = "";
        String nonMonetary = "";//нܷǽX
        String notTaxable = "";//˰
        String s93Str = "";
        String leftStr = "";
        String txt01 = "00";
        String txt02 = "00";
        String reserved = "";
        while (rowSet.next()) {
            //orgName = rowSet.getString("orgName");
            orgCode = rowSet.getString("orgCode");//
            personOccTion = rowSet.getString("personOccTion") == null ? "" : rowSet.getString("personOccTion");//˰
            String personChineX = rowSet.getString("personChineX") == null ? "" : rowSet.getString("personChineX");//
            String personChineM = rowSet.getString("personChineM") == null ? "" : rowSet.getString("personChineM");//
            String personPX = rowSet.getString("personPX") == null ? "" : rowSet.getString("personPX");//
            String personPM = rowSet.getString("personPM") == null ? "" : rowSet.getString("personPM");//
            BigDecimal s5 = rowSet.getBigDecimal("s5");//Ӧ˰ö
            BigDecimal s93 = rowSet.getBigDecimal("s93");//ְҵ˰
            Date bizDate = rowSet.getDate("bizDate");//Աְ
            if (bizDate != null){
                leftStr = outputFormatter.format(bizDate);
            }
            String[] s5split = convertToString(s5).split("\\.");
            String strS5 = s5split[0];
            if (StringUtils.isNotBlank(strS5)){
                if (convertToBigDecimal(strS5).compareTo(BigDecimal.ZERO) > 0){
                    s5Str += strLengthReturn(strS5,11,"0",0);
                }
            }
            s5Str += s5split[1];


            String[] s93split = convertToString(s93).split("\\.");
            String strS93 = s93split[0];
            if (StringUtils.isNotBlank(strS93)){
                if (convertToBigDecimal(strS93).compareTo(BigDecimal.ZERO) > 0){
                    s93Str += strLengthReturn(strS93,11,"0",0);
                }
            }
            s93Str += s93split[1];
            /**
             * ԱӦ֯   --7
             * Ӫҵ˰Żlֲ    --1
             * Աѯ ͳ  --4
             * ְҵ˰ Ĭ 32  --2
             * ԱϢ--˰  --8
             * ԱϢ-- (Big-5a)  --40
             * ԱϢ--  --40
             * н--Ӧ˰ö  --13
             * нܷǽǮ   --1
             * ˰    --13
             * н--ְҵ˰  --13
             * Աְ  --8
             * Ĭ 01  --2
             * Ĭ 12  --2
             * Ԥպʹ   --20
             */
            ChineName = stringToBig5Bytes(personChineX + personChineM);
            ChinePWName = personPX + personPM;
            orgCode = strLengthReturn(orgCode,7,"0",0);//
            taxFile = strLengthReturn("",1," ",0);//Ӫҵ˰Żlֲ


            personOccTion = strLengthReturn(personOccTion,8," ",personOccTion.length());//˰
            ChineName = strLengthReturn(ChineName,40," ",ChineName.length());//
            ChinePWName = strLengthReturn(ChinePWName,40," ",ChinePWName.length());//
            //s5 = strLengthReturn(removeTrailingZeros(s5),13,"0",0);//Ӧ˰ö
            nonMonetary = strLengthReturn("",1," ",0);//нܷǽX
            notTaxable = strLengthReturn("",13,"0",0);//˰
            //s93 = strLengthReturn(removeTrailingZeros(s93),13,"0",0);//ְҵ˰
            leftStr = strLengthReturn(leftStr,8,"0",leftStr.length());//Աְ


            reserved = strLengthReturn("",20," ",0);//Ԥպʹ

        }

        return orgCode+ taxFile + ctbPeriodyear + clauseNumber+ personOccTion+ ChineName+ ChinePWName+ s5Str+ nonMonetary+ notTaxable+ s93Str+ leftStr+ txt01+ txt02+ reserved;
    }


    public BigDecimal convertToBigDecimal(String numberAsString) {
        return new BigDecimal(numberAsString);
    }

    public String convertToString(BigDecimal number) {
        BigDecimal bigDecimal = number.setScale(2, RoundingMode.HALF_UP.ordinal());
        return bigDecimal.toString();
    }

    /**
     * תΪbig-5룬16
     * @param input
     * @return
     */
    public String stringToBig5Bytes(String input) {
        byte[] big5s = input.getBytes(Charset.forName("Big5"));// ʹ Big-5 תַ
        StringBuilder hexString = new StringBuilder(); // һ StringBuilder ڹַ
        for (byte b : big5s) {
            hexString.append(String.format("%02X", b)); // ÿֽڸʽΪʮƲӵַ
        }
        return hexString.toString();
    }

    /**
     * ַжϳȣʱƴ滻ֵ
     * @param value
     * @param totalLength ܳ
     * @param replaceValue 滻ֵ
     * @return
     * @throws Exception
     */
    public String strLengthReturn(String value ,int totalLength,String replaceValue ,int replacePosition ) throws Exception {
        if (value.length() > totalLength){
            throw new Exception("");
        }
        if (value.length() < totalLength) {
            StringBuilder stringBuilder = new StringBuilder(value);

            // 滻λ֮ǰ滻ֵ
            while (stringBuilder.length() < totalLength) {
                stringBuilder.insert(replacePosition, replaceValue);
            }
            value = stringBuilder.toString();
        }
        return value;
    }



}
